/***************************************************************************
 ** $Id: customlevel.h,v 1.3 2004/01/28 04:22:48 wiecko Exp $
                          klearnnotes2
                          customlevel.h -  description
                             -------------------
    begin                : Wed Oct  8 15:32:54 CEST 2003
    copyright            : (C) 2003 by Marek Wieckowski
    email                : wiecko AT users.sourceforge.net
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CUSTOMLEVEL_H
#define CUSTOMLEVEL_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QGroupBox;
class QLabel;
class QPushButton;
class QSpinBox;

//! a class for custom speed goal dialog

class CustomLevel : public QDialog
{ 
  Q_OBJECT

    public:
  //! constructor
  CustomLevel( QPixmap pmapForWhatsThisButton, QWidget* parent,
	       int val2, int val7,
	       int last2=0, int last7=0,
	       const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  //! destructor
  ~CustomLevel();

  //! custom speed goal for 2 name pushButtons active
  QSpinBox* spinBox_speed2;
  //! comments for spinBox_speed2: its "easy/reasonable/hard"
  QLabel* comments2;
  //! auto-interpolated speeds for 3 to 6 name pushButtons active
  QLabel* speed36[4]; 
  //! custom speed goal for 7 name pushButtons active
  QSpinBox* spinBox_speed7;
  //! comments for spinBox_speed7: its "easy/reasonable/hard"
  QLabel* comments7;

  QLabel* labelComments;

  QGroupBox* GroupBox2;
  //! button which sets preset easy ("Prentice") defaults
  QPushButton* pushButton_goal0;//prentice
  //! button which sets preset normal ("Journeyman") defaults
  QPushButton* pushButton_goal1;//journeyman
  //! button which sets preset hard ("Wizard") defaults
  QPushButton* pushButton_goal2;//wizard
  //! button which restors user's last custom settings
  QPushButton* pushButton_lastCustom;//last custom
  //! just for clearer layout
  QLabel* empty_label;
  // "What's this?" pushButton
  QPushButton* pushButton_what;
  QPushButton* pushButton_ok; //OK 
  QPushButton* pushButton_cancel; //Cancel


  public slots:
    //! slot which copies preset easy ("Prentice") defaults
    virtual void pushButton_goal0_clicked();
  //! slot which copies preset normal ("Journeyman") defaults
  virtual void pushButton_goal1_clicked();
  //! slot which copies preset hard ("Wizard") defaults
  virtual void pushButton_goal2_clicked();
  //! slot which restors user's last custom settings
  virtual void pushButton_lastCustom_clicked();
  virtual void pushButton_what_clicked();
  virtual void pushButton_OK_clicked();
  virtual void pushButton_cancel_clicked();
  //! calculates and displays interplolated speeds for 3 to 6 buttons active
  virtual void setupSpeeds36( int ignore=0);

 private:
  //!last custom speed for 2 namebuttons
  int lastSpeed2;
  //!last custom speed for 7 namebuttons
  int lastSpeed7;
};

#endif // CUSTOMLEVEL_H
