/***************************************************************************
 ** $Id: midi-OSS.h,v 1.2 2004/05/13 02:57:20 wiecko Exp $
                          klearnnotes2
                          midi-OSS.h -  description
                             -------------------
    begin                : Sun Feb 29 23:58:22 CET 2004
    copyright            : (C) 2004 by Marek Wieckowski
    email                : wiecko AT users.sourceforge.net
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KLN_MIDI_OSS_H
#define KLN_MIDI_OSS_H

#define MIDI_DEV "/dev/sequencer"

#include "midi.h"


class OSSMidiOutput : public MidiOutput
{
 public:
  OSSMidiOutput();
  virtual ~OSSMidiOutput();

  // overridden stuff:
  //! Opens /dev/sequencer and does basic setup. Returns true if successful.
  virtual bool turnOn();
  //! Closes /dev/sequencer
  virtual void turnOff();


  //! adds (schedules) one note to be played in next chord (in future)
  /*! pitch is a MIDI pitch (tune number) */
  virtual void addNoteToChord(int pitch);// for polyphony: you first add 
  //                                        notes ...
  //! plays all scheduled notes as a chord
  virtual void playChord();//                ... and then play whole chord


  //! Returns true if /dev/mixer or other apropriate "device" can be opened
  virtual bool mixerIsOpen();
  //! Sets mixer master volume
  virtual void mixerSetMasterVolume(int newvol);
  //! Sets mixer midi volume
  virtual void mixerSetMidiVolume(int newvol);
  //! Returns current master volume.
  virtual int  mixerMasterVolume();
  //! Returns current midi volume.
  virtual int  mixerMidiVolume();

  //! Updated patches of all channels.
  /*! Should be called when midiPatch changes. Always run when MIDI
    sound is turned on.
  */
  virtual void setupPatches();

protected:

  static const int maxNotesInAChord=40 ;
  //                                ^ this size should be >= no. of channels
  int notesToPlay[maxNotesInAChord]; // notes in one chord;
  int noOfNotesToPlay;
};
#endif //KLN_MIDI_OSS_H
