/***************************************************************************
 ** $Id: midi.cpp,v 1.7 2004/05/13 02:57:20 wiecko Exp $
                          klearnnotes2
                          midi.cpp -  description
                             -------------------
    begin                : Wed Oct  8 15:32:54 CEST 2003
    copyright            : (C) 2003 by Marek Wieckowski
    email                : wiecko AT users.sourceforge.net
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qprocess.h>

#include "klearnnotes2-defs.h"
#include "globals.h"
#include "midi.h"
extern MidiOutput* midiOutput;

MidiOutput::MidiOutput()
{
  midiMaxChan=defMIDIchan; // channel modulus
  midiCurrentDevice=defMIDIdevNum;
  midiCurrentVolume=defMIDIvol; 
  midiCurrentMasterVolume=defMASTERvol;
  midiCurrentChannel=0;
}

MidiOutput::~MidiOutput(){}
QString MidiOutput::getMidiOutputName(){return midiOutputName;}
bool MidiOutput::isOn()
{
  if(internal_midifd==-1)
    return false;
  return true;
}
void MidiOutput::setNoteLength(int newLength){noteLength=newLength;}
int  MidiOutput::getNoteLength(){return noteLength;}
void MidiOutput::setNoteVelocity(int newVelocity){noteVelocity=newVelocity;}
int  MidiOutput::getNoteVelocity(){return noteVelocity;}
void MidiOutput::setMidiPatch(int newPatch)
{
  midiPatch=newPatch;
  setupPatches();
}
int  MidiOutput::getMidiPatch(){return midiPatch;}
int  MidiOutput::getMidiMaxChan(){return midiMaxChan;}
int  MidiOutput::getMidiCurrentChannel(){return midiCurrentChannel; }
int  MidiOutput::getMidiCurrentDevice(){return midiCurrentDevice ;}
void MidiOutput::setMidiMaxChan(int newval){midiMaxChan=newval;}
void MidiOutput::setMidiCurrentChannel(int newval){midiCurrentChannel=newval; }
void MidiOutput::setMidiCurrentDevice(int newval){midiCurrentDevice=newval ;}
int  MidiOutput::getMidiCurrentVolume(){return midiCurrentVolume;}
int  MidiOutput::getMidiCurrentMasterVolume(){return midiCurrentMasterVolume;}


int MidiOutput::noteLength=defNOTElength;
int MidiOutput::noteVelocity=60;
int MidiOutput::midiPatch=defMIDIpatch;
bool MidiOutput::tryToSuspendArts=true;


bool MidiOutput::turnOn(void) {return true;}
void MidiOutput::turnOff(void){}
void MidiOutput::addNoteToChord(int foo)
{
  foo++;//just to make compiler not to complain about unused variable...
}
void MidiOutput::playChord(){}
bool MidiOutput::mixerIsOpen(){return true;}
void MidiOutput::mixerSetMasterVolume(int foo)
{
  foo++;//just to make compiler not to complain about unused variable...
}
void MidiOutput::mixerSetMidiVolume(int foo)
{
  foo++;//just to make compiler not to complain about unused variable...
}
int MidiOutput::mixerMasterVolume(){return getMidiCurrentVolume() ;}
int MidiOutput::mixerMidiVolume(){return getMidiCurrentMasterVolume();}
void MidiOutput::setupPatches(){}

void MidiOutput::suspendArts()
{
  if(tryToSuspendArts&&(midiOutput->getMidiOutputName()!=QString("aRts/TSE")))
    {
      //		  debuginfo("starting artsSuspendProcess");
      QProcess* artsSuspendProcess=new QProcess();
      artsSuspendProcess->clearArguments ();
      artsSuspendProcess->addArgument( "artsshell" );
      artsSuspendProcess->addArgument( "suspend" );
      if(!artsSuspendProcess->start())
	{
	  // debuginfo("artsSuspendProcess will not be started "
	  //	"anymore");
	  tryToSuspendArts=false; // probably no artsshell in PATH
	}
      else
	{ //give 0.5s time for suspend
	  KLN_usleep(500000);
	}
      delete artsSuspendProcess;
    }
}
