/***************************************************************************
 ** $Id: scalenotation.cpp,v 1.1 2004/04/11 06:25:55 fcuenca Exp $
                          klearnnotes2
                          scalenotation.cpp
                             -------------------
    begin                : Sun Mar 7 22:13:54 CEST 2003
    copyright            : (C) 2003 by Marek Wieckowski
    email                : wiecko AT users.sourceforge.net
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "scalenotation.h"

ScaleNotation::~ScaleNotation()
{
}

QString ScaleNotation::getNoteLongLabel(ScaleNote noteName, NoteAccident noteAcc) const
{
   QString name = getNoteLabel(noteName, evNatural); // Use the natural name as base
   QString accident;

   switch(noteAcc)
   {
       case evSharp:
           accident = "sharp";
           break;

       case evFlat:
           accident = "flat";
           break;

       case evNatural:
       default:
           // keep the compiler happy
           break;
   };
   
   if(accident.isEmpty())
   {
      return QString(tr("%1","name of a note").arg(tr(name)));
   }
   else
   {
      return QString(tr("%1 %2","name of a note; #1 may be 'sharp' or 'flat'").
                       arg(tr(name)).arg(tr(accident)));
   }
}


