/***************************************************************************
 ** $Id: solfeggionotation.cpp,v 1.2 2004/05/13 02:57:20 wiecko Exp $
                          klearnnotes2
                          solfeggionotation.cpp
                             -------------------
    begin                : Sun Mar 7 22:13:54 CEST 2003
    copyright            : (C) 2003 by Marek Wieckowski
    email                : wiecko AT users.sourceforge.net
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <assert.h>
#include "solfeggionotation.h"
#include "globals.h"

QString SolfeggioNotation::getNoteLabel(ScaleNote noteName, NoteAccident noteAcc) const
{
  QString name, acc;

  switch(noteName)
    {
    case evA:
      name = "La";
      break;
            
    case evB:
      name = "Ti"; // using "Ti" for "Si", to avoid confusion with English letter "C"
      break;
            
    case evC:
      name = "Do";
      break;
            
    case evD:
      name = "Re";
      break;
            
    case evE:
      name = "Mi";
      break;
            
    case evF:
      name = "Fa";
      break;
            
    case evG:
      name = "Sol";
      break;

    default:
      assert(false); // this should not happen!
    }

  switch(noteAcc)
    {
    case evSharp:
      acc = "#";
      break;

    case evFlat:
      acc = "b";
      break;

    case evNatural:
      // keep the compiler happy
      break;
      
    default: // natural
      debuginfo("wrong accidental");
      //            assert(false); // this should not happen!
    }
    
  return name + acc;
}

int SolfeggioNotation::getNoteChar(ScaleNote noteName, NoteAccident) const
{
  int noteChar = 0;
    
  switch(noteName)
    {
    case evA:
      noteChar = 'L';
      break;
            
    case evB:
      noteChar = 'T'; 
      break;
            
    case evC:
      noteChar = 'D';
      break;
            
    case evD:
      noteChar = 'R';
      break;
            
    case evE:
      noteChar = 'M';
      break;
            
    case evF:
      noteChar = 'F';
      break;
            
    case evG:
      noteChar = 'S';
      break;

    default:
      assert(false); // this should not happen!
    }

  return noteChar;
}

