/***************************************************************************
 ** $Id: voice_recognition.h,v 1.9 2004/02/12 07:32:44 wiecko Exp $
                          klearnnotes2
                          voice_recognition.h -  description
                             -------------------
    begin                : Thu Oct 23 03:55:46 CEST 2003
    copyright            : (C) 2003 by Marek Wieckowski
    email                : wiecko AT users.sourceforge.net
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VOICE_RECOGNITION_H
#define VOICE_RECOGNITION_H
#include <qtranslator.h>

// cmd_X defines label by which cvoicecontrol informs the main program
// about user input; this is actual 'label' in the 'model'

// txt_X is what user sees in the listview

// sug_X is a suggestion for recording

#define cmd_no      "NO"
#define txt_no      QT_TRANSLATE_NOOP("voice command","NO")
#define sug_no      QT_TRANSLATE_NOOP("voice command","try recording 'button NO' or 'click on NO'")
#define cmd_yes     "YES"
#define txt_yes     QT_TRANSLATE_NOOP("voice command","YES")
#define sug_yes     QT_TRANSLATE_NOOP("voice command","try recording 'button YES' or 'click on YES'")

//! voice command: "Quit program" - identifier
#define cmd_quit    "QUIT_program"
//! voice command: "Quit program" - user visible command name
#define txt_quit    QT_TRANSLATE_NOOP("voice command","QUIT program")
//! voice command: "Quit program" - sample recording suggestion
#define sug_quit    QT_TRANSLATE_NOOP("voice command","just record 'QUIT program'")

#define cmd_help    "HELP"
#define txt_help    QT_TRANSLATE_NOOP("voice command","HELP")
#define sug_help    QT_TRANSLATE_NOOP("voice command","try recording 'HELP' or 'get HELP'")

#define cmd_quieter "QUIETER"
#define txt_quieter QT_TRANSLATE_NOOP("voice command","QUIETER")
#define sug_quieter QT_TRANSLATE_NOOP("voice command","try recording 'QUIETER' or 'sound QUIETER'")
#define cmd_louder  "LOUDER"
#define txt_louder  QT_TRANSLATE_NOOP("voice command","LOUDER")
#define sug_louder  QT_TRANSLATE_NOOP("voice command","try recording 'LOUDER' or 'sound LOUDER'")
#define cmd_sndSetup "SOUND_SETUP"
#define txt_sndSetup QT_TRANSLATE_NOOP("voice command","open SOUND SETUP dialog")
#define sug_sndSetup QT_TRANSLATE_NOOP("voice command","just record 'sound SETUP'")
#define cmd_sndOn   "SOUND_ON"
#define txt_sndOn   QT_TRANSLATE_NOOP("voice command","turn SOUND ON")
#define sug_sndOn   QT_TRANSLATE_NOOP("voice command","just record 'sound ON'")
#define cmd_sndOff  "SOUND_OFF"
#define txt_sndOff  QT_TRANSLATE_NOOP("voice command","turn SOUND OFF")
#define sug_sndOff  QT_TRANSLATE_NOOP("voice command","just record 'sound OFF'")

#define cmd_none    "all_NOTES_NOT_ACTIVE"
#define txt_none    QT_TRANSLATE_NOOP("voice command","set all NOTES NOT ACTIVE")
#define sug_none    QT_TRANSLATE_NOOP("voice command","just record 'all notes NOT active'")
#define cmd_all     "all_NOTES_ACTIVE"
#define txt_all     QT_TRANSLATE_NOOP("voice command","set all NOTES ACTIVE")
#define sug_all     QT_TRANSLATE_NOOP("voice command","just record 'all notes active'")
#define cmd_length  "test_LENGTH"
#define txt_length  QT_TRANSLATE_NOOP("voice command","open TEST LENGTH dialog")
#define sug_length  QT_TRANSLATE_NOOP("voice command","just record 'test LENGTH'")
#define cmd_next    "NEXT_exercise"
#define txt_next    QT_TRANSLATE_NOOP("voice command","NEXT exercise")
#define sug_next    QT_TRANSLATE_NOOP("voice command","just record 'NEXT exercise'")
#define cmd_treble  "TREBLE_clef"
#define txt_treble  QT_TRANSLATE_NOOP("voice command","choose TREBLE clef")
#define sug_treble  QT_TRANSLATE_NOOP("voice command","just record 'TREBLE clef'")
#define cmd_bass    "BASS_clef"
#define txt_bass    QT_TRANSLATE_NOOP("voice command","choose BASS clef")
#define sug_bass    QT_TRANSLATE_NOOP("voice command","just record 'BASS clef'")

#define cmd_stop    "STOP_test"
#define txt_stop    QT_TRANSLATE_NOOP("voice command","STOP test")
#define sug_stop    QT_TRANSLATE_NOOP("voice command","just record 'test-STOP' ('ST' in the\nbeginning may be mis-recognized!)")
#define cmd_start   "START_test"
#define txt_start   QT_TRANSLATE_NOOP("voice command","START test")
#define sug_start   QT_TRANSLATE_NOOP("voice command","just record 'test-START' ('ST' in the\nbeginning may be mis-recognized!)")

//! number of voice commands defined by cmd_ txt_ and sug_
#define NUMCOMMANDS 17
//! number of head-items (directory-like containers for voice commandItems):
#define NUMHEADS 4

///////// NOT USED YET:
// similar definitions for notes with sharps/flats:
// 
// how to take care of German/English notation automatically?
//
// Notes with sharps:
#define cmd_csharp   "csharp"
#define txt_csharp   QT_TRANSLATE_NOOP("voice command","C sharp")
#define cmd_dsharp   "dsharp"
#define txt_dsharp   QT_TRANSLATE_NOOP("voice command","D sharp")
#define cmd_fsharp   "fsharp"
#define txt_fsharp   QT_TRANSLATE_NOOP("voice command","F sharp")
#define cmd_gsharp   "gsharp"
#define txt_gsharp   QT_TRANSLATE_NOOP("voice command","G sharp")
#define cmd_asharp   "asharp"
#define txt_asharp   QT_TRANSLATE_NOOP("voice command","A sharp")
// Notes with flats:
#define cmd_dflat   "dflat"
#define txt_dflat   QT_TRANSLATE_NOOP("voice command","D flat")
#define cmd_eflat   "eflat"
#define txt_eflat   QT_TRANSLATE_NOOP("voice command","E flat")
#define cmd_gflat   "gflat"
#define txt_gflat   QT_TRANSLATE_NOOP("voice command","G flat")
#define cmd_aflat   "aflat"
#define txt_aflat   QT_TRANSLATE_NOOP("voice command","A flat")
#define cmd_hflat   "hflat"
#define txt_hflat   QT_TRANSLATE_NOOP("voice command","H flat")
#define cmd_bflat   "bflat"
#define txt_bflat   QT_TRANSLATE_NOOP("voice command","B flat")



#include <qvariant.h>
#include <kdialogbase.h>
#include <qpixmap.h>
#include <kfiledialog.h>
#include <qlistview.h>
/***************************************************************************
 based on microphone_config.h from cvoicecontrol-0.9alpha by Daniel Kiecza
***************************************************************************/

#ifndef MICROPHONE_CONFIG_H
#define MICROPHONE_CONFIG_H

extern "C" {
#include "mixer.h"
#include "audio.h"
#include "model.h"
}
#include <time.h>

extern MixerDevices *mixer_devices;
extern AudioDevices *audio_devices;

/*!****
      fraction of max level (=32768) below which the signal is
      considered to represent silence
*****/
extern float silence ;/*   = 0.02;*/
/*!****
      fraction of max level (=32768) below which the signal is
      considered to represent (too) low volume speech
*****/
extern float low_volume ;/*= 0.15;*/
/*!****
      fraction of max level (=32768) above which the signal is
      considered to represent (too) high volume speech
*****/
extern float high_volume ;/*= 0.75;*/

#define MIN_REASONABLE_MIC_LEVEL   20
#define MAX_REASONABLE_IGAIN_LEVEL 50

#endif
//************ end - Kiecza's microphone_config.h

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QPushButton;
class QSpinBox;
class QComboBox;
class QMessageBox;



//! max number of pages in this wizard dialog window
#define MAXPAGE 10

//unsigned char *getUtterance(int *length);

//! microphone setup for voice recognition wizard dialog
class DVoiceMicroSetup : public KDialogBase
{ 
  Q_OBJECT

    public:
  DVoiceMicroSetup(QWidget* parent = 0,
		   const char* name = 0, bool modal = FALSE);
  ~DVoiceMicroSetup();

  protected slots:
    virtual void slotOK();
  virtual void slotCancel();
  virtual void slotClose();
//! next
  virtual void slotUser1();
//! previous
  virtual void slotUser2();
//! about
  virtual void slotUser3();

//! second part of constructor
/*! There are certain things you cannot do in the constructor. For example
	quitting is quite tricky. Therefore, the constructor is split into two
	parts. At the end of the first part a QTimer::singleShot is run - it 
	calls constructorPart2() after a specified amount of time. 
*/
  virtual void constructorPart2();
  //! page 1:
  virtual void combo_mixer_activated(int);
  //! page 1:
  virtual void combo_audio_activated(int);
  //! page 2:
  virtual void adjust_miclevel();
  //! page 3:
  virtual void pushButton_threshold_clicked();
  //! page 4:
  virtual void pushButton_character_clicked();
  //! page 5:
  virtual void pushButton_save_clicked();

 protected:
  virtual void setupPage(int newPageNumber);
//! just a shortcut to standard message QDialog
  virtual void infoPopup(const QString txt,
			 const QString tit=QT_TR_NOOP("Microphone setup:")) ;
//! just a shortcut to standard warning QDialog
  virtual void warningPopup(const QString txt,
			    const QString tit=QT_TR_NOOP("Microphone setup:"));
//! shows a popup dialog before closing the microphone setup dialog
  virtual void exitWithError(const QString* txt);



  /*! inactive = not available for user yet
      invalid  = available, but not set right
      ok  = available and set right
  */
  enum state {inactive, invalid, ok};

  enum state status[7];/* = {invalid, invalid, inactive, inactive, inactive,
			  inactive, invalid};*/

  QVBox * dialogMicroBox;
  QFrame* leftFrame;
//! right frames for each page
  QFrame* rightFrame[MAXPAGE];
//! warning-on-cancel txts - for now the same txt for each frame
  QString* warntxt[MAXPAGE];
//! left frames: info txts
  QString* infotxt[MAXPAGE]; 
//! titles for each wizard page
  QString* titletxt[MAXPAGE];

  QVBoxLayout * rightLayout;  // layout inside rightFrame; recycled ;)


//! current page number
  int currentPage;
//! number of the last page
/*! It has to be smaller than \def MAXPAGE. */
  int endPage; 


  //! \name page 1:
  //@{
  QComboBox*   combo_mixer ;
  QLabel* comments_mixer;
  QComboBox*   combo_audio ;
  QLabel* comments_audio;
  //@}

  //! \name page2:
  //@{
  //! set by combo_mixer setup
  bool mixerIgainEnabled;
  //! microphone level
  int mic_level; 
  //! Input Gain level
  int igain_level;
  //! max 16-bit sample value coming from the sound card   
  int max_sample; 
  /**** temporary variables: */
  int count;
  int max_gain;
  QPushButton* pushButton_adjust_igain;
  QPushButton* pushButton_adjust_miclevel;
  QLabel* comment_miclevel;
  QLabel* label_miclevel_value;
  //@}

  //! \name page3:
  //@{
  QPushButton* pushButton_threshold;
  QLabel* comment_threshold;
  //@}

  //! \name page4:
  //@{
  QPushButton* pushButton_character;
  //@}

  //! \name page5:
  //@{
  QPushButton* pushButton_save;
  //@}

  QLabel* title;
  QLabel* info;

  QHBoxLayout* tmpHLayout;//recycled
  QLabel* tmpLabel; //recycled
  QString tmpString;
};

/***************************************************************************
 based on model_editor.h from cvoicecontrol-0.9alpha by Daniel Kiecza
***************************************************************************/
#define MIN_NR_SAMPLES_PER_ITEM 4

#include "keypressed.h"
#include "klearnnotes2.h"

//! voice model (speaker model) editor
/*! It enables recording samples of voice for each command that the user
	plans to activate by her voice, saving the model to a file or loading
	a previously saved model file.
*/
class DModelEditor: public KDialogBase
{ 
  Q_OBJECT

    public:
  DModelEditor(const QString filename="", KLearnNotes2* parent = 0,
	       const char* name = 0, bool modal = FALSE);
  ~DModelEditor();

  virtual void setKeypressed(bool pressed);

  protected slots:
    virtual void constructorPart2();
  virtual void slotClose();
  virtual void slotOk();
  virtual void slotCancel();
//! About
  virtual void slotUser1();// About
//! Save as
  virtual void slotUser2(); // Save as...
//! Save
  virtual void slotUser3(); // Save
  virtual void pushButton_loadModel_clicked();
  virtual void pushButton_saveAs_clicked();
  virtual void pushButton_save_clicked();
  virtual void startNewModel();

  //! \name page 2 (notes tab) only:
  //@{
  virtual void selectedNoteChanged(QListViewItem * newItem);
  virtual void pushButton_play2_clicked();
  virtual void pushButton_delete2_clicked();
  virtual void pushButton_deleteAll2_clicked();
  virtual void pushButton_record2_clicked();
  //  virtual void pushButton_record2_clicked_Part2();
  //@}

  //! \name page 3 (commands tab) only:
  //@{
  virtual void selectedCommandChanged(QListViewItem * tmpSignalItem);
  virtual void pushButton_play3_clicked();
  virtual void pushButton_deleteAll3_clicked();
  virtual void pushButton_delete3_clicked();
  virtual void pushButton_record3_clicked();
  //@}

 protected: 
//! returns true if selected listitem is a dir-like grouping header
  virtual bool isHead(QListViewItem * listItem);
//! confirms if changes in the model should be discarded
  virtual int safeResetModel();
//! shows a dialog and exits
  virtual void exitWithError(const QString* txt) ;
//! a shortcut to the standard message QDialog
  virtual void infoPopup(const QString txt,
			 const QString tit=QT_TR_NOOP("Voice speaker model editor:")); 
//! a shortcut to the standard warning QDialog
  virtual void warningPopup(const QString txt,
			    const QString tit=QT_TR_NOOP("Voice speaker model editor:"));
//! plays recorded sample
  int playSample(ModelItemSample *sample);
//! records new sample: opens /dev/dsp, does setup and runs getUtterance()
  ModelItemSample *recordSample();
//! actual recording; shows a dialog which enables cancelling without recording
  unsigned char * getUtterance(int *length); // moved from Kiecza's audio.c
  //       to make it react to Qt Cancel

  virtual void loadFile(const QString qsFileName);
  virtual void save(QString qsFileName);

//! writes model info to stdout
  virtual void debugModel();
//! number of note-name item in model
  virtual int noteItemNumber(QListViewItem * it); 
//! number of command-name item in model
  virtual int commandItemNumber(QListViewItem * it);
//! number of sample for note- or command- modelitem
  virtual int sampleNumber(ModelItem *,QString);
//! adds model items for all notes and commands
  virtual void addMissingItems();
//! deletes model items with no samples recorded; run before save()
  virtual void deleteEmptyItems();
//! updates labels (like "4 missing") after loading/saving a model
  virtual void updateModelViews();

//!\name cancelling sample recording
/*! for compatibility with Kiecza's code */
//@{
  virtual void initKeyPressed();
  virtual int keyPressed();
  virtual void endKeyPressed();
  int keypressed;
  KeyPressDialog* cancelDialog;
//@}

  Model *model;            /***** speaker model */
  char *model_file_name ;  /***** name of speaker model file */
  QString modelFileName; 
  int modified;            /***** tells whether the model has been modified */
  KLearnNotes2* papa;



  //!\name  PAGE 1:
  //@{
  QFrame *page1;
  QVBoxLayout *page1Layout;
  QHBoxLayout* tmpLayout;// recycle!
  QLabel* modelLabel;
  QLabel* lModelFile;

  QPushButton* pushButton_newModel;
  QPushButton* pushButton_loadModel;
  QPushButton* pushButton_saveModel;
  QPushButton* pushButton_saveModelAs;
  //@}

  //!\name PAGE 2:
  //@{
  QListView * noteList;
  QListViewItem* noteItems[7];


  QFrame *page2;
  QHBoxLayout *page2Layout;
  QVBoxLayout * rightLayout2;
  QLabel* lComments2;
  QListView* samplesList2;

  QPushButton* pushButton_record2;
  QLabel* lRecordLeft2;
  QPushButton* pushButton_play2;
  QPushButton* pushButton_delete2;
  //@}

  //!\name PAGE 3:
  //@{
  QListView * commandList;
  QListViewItem* commandItems[NUMCOMMANDS];
  QString* commandStrings[NUMCOMMANDS][3];
  QListViewItem* head[NUMHEADS];

  QFrame *page3;
  QHBoxLayout *page3Layout;
  QVBoxLayout * rightLayout3;
  QLabel* lComments3;
  QListView* samplesList3;
  QPushButton* pushButton_record3;
  QLabel* lRecordLeft3;
  QPushButton* pushButton_play3;
  QPushButton* pushButton_delete3;

  QListViewItem* lastNoteItem;
  QListViewItem* lastCommandItem;
  //@}
};

#endif // VOICE_RECOGNITION_H
